unit Unit1;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.Controls.Presentation, FMX.StdCtrls, FMX.TMSBaseControl, FMX.TMSTableView;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    TableView1: TTMSFMXTableView;
    ButtonAddItem: TButton;
    procedure FormCreate(Sender: TObject);
    procedure ButtonAddItemClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.fmx}

procedure TForm1.FormCreate(Sender: TObject);
var
  I : Integer;
  Item : TTMSFMXTableViewItem;
begin
  TableView1.BeginUpdate;
  try
    //TableView1.BufferSize := 0;
    TableView1.Items.Clear;
    for I := 0 to 4 do
    begin
      Item := TableView1.Items.Add;
      Item.Caption := 'Caption of item ' + IntToStr( I );
      Item.Description := 'Description of item ' + IntToStr( I );
      Item.Tag := I;
    end;
    TableView1.SelectedItemIndex := 0; // <--- if I remove this line, the ButtonAddItem works ok.
  finally
    TableView1.EndUpdate;
  end;
end;

procedure TForm1.ButtonAddItemClick(Sender: TObject);
var
  Item : TTMSFMXTableViewItem;
  I : Integer;
begin
  TableView1.BeginUpdate;
  try
    Item := TableView1.Items.Add;
    I := TableView1.Items.Count - 1;
    Item.Caption := 'Caption of item ' + IntToStr( I );
    Item.Description := 'Description of item ' + IntToStr( I );
    Item.Tag := I;
  finally
    TableView1.EndUpdate;
  end;
end;

end.
